using System;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Interval.BubbleSelectedEvent
{
	
	/// <summary>
	/// Summary description for BubbledIndexChangedEventArgs.
	/// </summary>
	public class BubbledIndexChangeEventArgs : EventArgs
	{
		#region private variables
		private DataGridItem m_item;
		private object m_source;
		#endregion private variables

		public BubbledIndexChangeEventArgs(DataGridItem item, object source) : base()
		{
			
			if (item == null)
				throw new ArgumentNullException("item");
			m_item = item;
			if (source == null)
				throw new ArgumentNullException("source");
			m_source = source;
			
			
		}
		#region properties
		/// <summary>
		///dek datagridu obsahujc pvodce udlosti
		/// </summary>
		public DataGridItem Item
		{
			get
			{
				return m_item;				
			}
		}

		/// <summary>
		/// Pvodce udlosti
		/// </summary>
		public object Source
		{
			get
			{
				return m_source;
			}
		}

		#endregion properties
	}
}
