using System;
using System.Web.UI.WebControls;

namespace Interval.BubbleSelectedEvent
{
	/// <summary>
	/// Datagrid s udlosti DropDownSelectedIndexChanged
	/// </summary>
	public class DataGridEx : DataGrid
	{
	
		protected static object DropDownSelectedIndexChangedKey = new Object();
		#region Events
		public delegate void DropDownSelectedIndexChangedEventHandler(object source, BubbledIndexChangeEventArgs e);
		/// <summary>
		/// Udlost DropDownSelectedIndexChanged, kter je vyvolna pi zmn vybran poloky ve vnoenm dropdownlistu
		/// </summary>
		public event DropDownSelectedIndexChangedEventHandler DropDownSelectedIndexChanged
		{
			add
			{
				Events.AddHandler(DropDownSelectedIndexChangedKey, value);
			}
			remove
			{
				Events.RemoveHandler(DropDownSelectedIndexChangedKey, value);
			}
		}
		
		#endregion Events
		
		#region Constructors
		/// <summary>
		/// Konstruktor
		/// </summary>
		public DataGridEx() : base()
		{
		
		}
		#endregion Events

		#region Protected methods
		/// <summary>
		/// Metoda je volna pi bubln udlosti 
		/// </summary>
		/// <param name="source">Zdroj udlosti</param>
		/// <param name="args">Argumenty udlosti</param>
		/// <returns>True - udlost byla zachycena, False - udlost nebyla zachycena</returns>
		protected override bool OnBubbleEvent(object source, EventArgs args)
		{
			if (args is BubbledIndexChangeEventArgs)
			{
				OnDropDownSelectedIndexChanged((BubbledIndexChangeEventArgs)args);
				return true;
			}
			
			else
				return base.OnBubbleEvent (source, args);
		}

		/// <summary>
		/// Metoda odpovdn za vyvoln udlosti <see cref="DropDownSelectedIndexChanged"/>
		/// </summary>
		/// <param name="e">Argumenty udlosti</param>
		protected virtual void OnDropDownSelectedIndexChanged(BubbledIndexChangeEventArgs e)
		{
			DropDownSelectedIndexChangedEventHandler eh = (DropDownSelectedIndexChangedEventHandler)Events[DropDownSelectedIndexChangedKey];
			if (eh != null)
				eh(this, e);
		}
		#endregion Protected methods


	}
}
